//author: Dustin Rhodes
//email: dcrhodes@ucsc.edu
/*This is the objecst used for my final project */
#include "Objects.h"
#include <stdio.h>
//#include<GL/glut.h>
//#include <GLUT/glut.h>
#include <GL/glut.h>
#include <unistd.h>
#include <math.h>
#include <fstream>
#include <iostream>
//using namespace std;

#define PI 3.14159265

int Object::bounce=1;

Ball::Ball(){
   sX=1; sY=1; sZ=1;
   x=0; y=1; z=0;
   r=1;
   moveable=1;
   startX=0; startY=0;
   vel=0.002;
}

//creats a new point with x,y, and z
Point::Point(float ax, float ay, float az){
   x=ax; y=ay; z=az;
   r=0.2;
}

void Object::draw(){

   fprintf(stderr,"no draw defined \n");
}

//tests for the mouse clicking on it the points are the mouse
//in world cordinates
int Object::mouseHit(float mx,float my){
   float dx = x-mx;
   float dy = y-my;
   float dist = sqrt(dx*dx+dy*dy);
   if(dist<r){
      return 1;
   }
   return 0;
}

//tests for the mouse clicking on it the points are the mouse
//in world cordinates
int Line::mouseHit(float mx, float my){
   if(start->mouseHit(mx,my)){
      whichClicked=1;
      return 1;
   }else if(end->mouseHit(mx,my)){
      whichClicked=2;
      return 2;
   }
   return 0;
}

float Point::length(){
   return sqrt(x*x+y*y+z*z);
}

void Point::scale(float a){
   x*=a; y*=a; z*=a;
}

int Object::hit(Object* toHit){
   float dist = sqrt((x-toHit->x)*(x-toHit->x)+(y-toHit->y)*(y-toHit->y));
   if(dist<r+toHit->r){
      moveOff(toHit);
      return 1;
   }
   return 0;
}

void Object::moveOff(Object* hit){
   Point* between = new Point(x-hit->x,y-hit->y,0);
   Point* betweenV = new Point(x-hit->x,y-hit->y,0);
   float scaleFactor = (r+hit->r)/between->length();
   float scaleFactorV = (sqrt(vX*vX+vY*vY))/betweenV->length();
//   hit->addForce(-between->x/1000,-between->y/1000);
   hit->x=x; hit->y=y;
   between->scale(scaleFactor);
   hit->x-=between->x; hit->y-=between->y;
   betweenV->scale(scaleFactorV);
   if(hit->moveable==3){
        betweenV->scale(1/betweenV->length());
        betweenV->scale(0.03);
   }
   hit->vX=-betweenV->x;
   hit->vY=-betweenV->y;
   vX=betweenV->x;
   vY=betweenV->y;
   if(vX>0.003)vX*=0.7;
   if(vY>0.003)vY*=0.7;
   if(hit->vX>0.003)hit->vX*=0.7;
   if(hit->vY>0.003)hit->vY*=0.7;
   collided=20;
   hit->collided=20;
}

void Object::addForce(float fX, float fY){
   vX+=fX;
   vY+=fY;
}

void Point::print(){
}

float Point::dot(Point* i){
   return x*i->x+ y*i->y + z*i->z;
}


//tests for a collision between this and a ball and if there is a hit
//it alters the ball acordingly
int Line::hit(Object* toHit){
   Point* dist = new Point(toHit->x - start->x, toHit->y - start->y, 0);
   Point* line = new Point(start->x - end->x, start->y - end->y, 0);
   float normalization = sqrt(line->x*line->x+line->y*line->y);
   line->x= line->x/(normalization);
   line->y= line->y/(normalization);
   float length = dist->dot(line);
   Point* vel = new Point(toHit->vX, toHit->vY, 0 );
   float parllelLength = vel->dot(line);
   length*=-1;
//   dist->print(); line->print();
   if(length<0)length=0;
   float lengthOfLine = sqrt( (start->x-end->x)*(start->x-end->x) +
                              (start->y-end->y)*(start->y-end->y) );
   if(length>lengthOfLine)length=lengthOfLine;

   float closeX = length*cos(theta)+start->x;
   float closeY = length*sin(theta)+start->y;

/*
   glLoadIdentity();
   glBegin(GL_LINES);
   glColor3f(0,1,0);
   glVertex3f(closeX,closeY,0);
   glVertex3f(toHit->x,toHit->y,0);
   glEnd();
   glLoadIdentity();
   */

   if(length==0 || length==lengthOfLine) return 0;

   float distX = closeX-toHit->x;
   float distY = closeY-toHit->y;

   if(distX*distX+distY*distY<(toHit->r*toHit->r)){
         if(onSurface==0){
            if(bounce){
                 line->x*=parllelLength;
                 line->y*=parllelLength;
            //fprintf(stderr,"parllel vy: %f %f \n",line->x,line->y);
            //fprintf(stderr,"before hit vy: %f %f \n",vel->x,vel->y);
                  vel->x=vel->x - line->x;
                  vel->y=vel->y - line->y;
                  vel->x*=2; vel->y*=2;
            //fprintf(stderr,"perpindicular vy: %f %f \n",vel->x,vel->y);
               toHit->vX-=vel->x; toHit->vY-=vel->y;
            } 
            onSurface=1;
            
            return 1;
            
         }
         float toScale = toHit->r/sqrt(distX*distX+distY*distY);
         if(distX!=0 &distY!=0){ 
                 toHit->x+=distX;
                 toHit->y+=distY;
                 distX*=toScale; distY*=toScale;
                 toHit->x-=distX;
                 toHit->y-=distY;
         }

//         toHit->x+=

         float fX = -0.00002*tan(theta);
         float run = start->x - end->x;
         float rise = start->y - end->y;

         toHit->addForce(fX,0);
         if(onSurface!=0){
                 //fprintf(stderr,"not first hit \n");
            toHit->vY = toHit->vX/run * rise;
         }


      return 1;
   }

   toHit->oldPerpX=distX;
   toHit->oldPerpY=distY;

   onSurface=0;
   return 0;

}
void Object::move(float ax, float ay){
   x=ax; y=ay;
   vX=0; vY=0;
}

void Line::move(float ax, float ay){
   if(whichClicked==1){
      start->move(ax,ay);
   }else{
      end->move(ax,ay);
   }

}


float decrease(float x, float by){
    if(x >  by)return x-by;
    if(x < -by)return x+by;
    else return x;
}

//draws the ball
void Ball::draw(void){
  if(moveable==1){
          y+=vY;
          x+=vX;
          decrease(vX,0.001);
          decrease(vY,0.001);
         glColor3f(1,0.5,0);
  }else if(moveable==0){
      glColor3f(0,0.5,1);
  }else if(moveable==2){
      if(startX==0)startX=x;
      glColor3f(1,0,0.5);
      x+=vel;
      if(x>startX+1 || x<startX-1)vel*=-1;
  }else if(moveable==3){
      glColor3f(0,1,0.5);
      if(collided){
        glColor3f(1,1,1);
        collided--;
      }
  }
  
         glLoadIdentity();
         glTranslatef(x,y,z);
         glutSolidSphere(r,15,15);
         glLoadIdentity();
}

//draws the lines plus the diamonds
void Line::draw(){
    start->r=0.5;
    end->r=0.5;
   glBegin(GL_LINES);
   glColor3f(0,1,0);
   glVertex3f(start->x,start->y,start->z);
   glVertex3f(end->x,end->y,end->z);
   glEnd();

   glTranslatef(start->x,start->y,start->z);
   glutSolidSphere(start->r,4,4);
   glLoadIdentity();
   glTranslatef(end->x,end->y,end->z);
   glutSolidSphere(end->r,4,4);

   float rise = start->y - end->y;
   float run = start->x - end->x;
   theta = atan(rise/run);
   if(end->x<=start->x)theta=PI+theta;
}
