#ifndef HEADERS
#define HEADERS
/* this is the header for the object class
it represents a 3d wireframe model.

All method comments are in the .cc file
*/

#include <vector>
#include <utility>
using namespace std;


class Object{
   public:
      float x,y,z;
      float vX,vY,vZ;
      float oldX, oldY;
      float oldPerpX, oldPerpY;
      float r;
      int onSurface;
      int moveable;
      int collided;
      static int bounce;
      virtual void draw();
      virtual int hit(Object* toHit);
      virtual int mouseHit(float,float);
      virtual void move(float,float);
      virtual void moveOff(Object* toMove);
      void addForce(float,float);
};

class Point: public Object{
   public:
      float nx,ny,nz;
      Point(float,float,float);
      void print();
      float dot(Point* i);
      float length();
      void scale(float);
};

class Poly{
   public:
           vector<int> points;
           float nx,ny,nz;
};

class Line: public Object{
  public:
         int whichClicked;
         float theta;
          Point* start;
          Point* end;
          void draw();
          void move(float, float);
          int mouseHit(float,float);
          int hit(Object* toHit);
};

class Ball: public Object{
public:
   float xTheta,yTheta,zTheta;
   float sX,sY,sZ;
   float aX,aY,aZ;


   float vel;
   float startX;
   float startY;
   void draw();
   int smooth;
   int wire;
   Ball();
};

#endif HEADERS
